#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

struct Eesnimi      // uue andmetbi "Eesnimi" definitsioon
{
    string enimi;
    int sagedus;
};
/*
    Eesnimi uus;    // "uus" on struct-(kirje-)tpi muutuja
    uus.enimi = "Karla";
    uus.sagedus++;

    Eesnimi a[1001];
*/
struct Perenimi
{
    string pnimi;
    int indeks;     // eesnime indeks vektoris nimi
};

vector<Eesnimi> nimi;
vector<Perenimi> liige;
/*
    vector<T> x;   x on muutva pikkusega T-tpi elementide massiiv

        x.size() - elementide arv (vaikimisi 0)
        x.push_back(t) - elemendi t lisamine massiivi lppu
        x[i] - prdumine massiivi i-nda elemendi poole; 0<=i<x.size()-1
*/

int lisaEesnimi(string s)
{
    for(int j=0;j<nimi.size();j++)
    {
        if(s==nimi[j].enimi)
        {
            nimi[j].sagedus++;
            return j;
        }
    }
    Eesnimi uus;
    uus.enimi = s;
    uus.sagedus = 1;
    nimi.push_back(uus);
    return nimi.size()-1;
}

int main()
{
    ifstream input("..\\Riigikogu.txt");
    if(not input.is_open())
    {
        cout<<"Faili ei saa avada!\n";
        return 0;
    }

    while(input.good())
    {
        string line;
        getline(input,line);
        cout << line << endl;
        int pos = line.find_first_of(" ");
        line = line.substr(pos+1);
        pos = line.find_first_of(" ");
        cout<<line.substr(0,pos)<<endl;
        cout<<line.substr(pos+1)<<endl;

        Perenimi p;
        p.indeks = lisaEesnimi(line.substr(0,pos));
        p.pnimi = line.substr(pos+1);
        liige.push_back(p);

    }
    input.close();

    int maxSagedus = 0;
    for(int j=0;j<nimi.size();j++)
    {
        if(nimi[j].sagedus>maxSagedus)
            maxSagedus = nimi[j].sagedus;
    }

    cout<<"\nMax sagedus = "<<maxSagedus<<endl;
     for(int j=0;j<nimi.size();j++)
    {
        if(nimi[j].sagedus==maxSagedus)
        {
            string n = nimi[j].enimi;
            // printida kik liikemed, kelle eesnimi==n
            for(int i=0;i<liige.size();i++)
                if(liige[i].indeks==j)
                    cout<<n<<" "<<liige[i].pnimi<<endl;
        }
    }
    return 0;
}

/*
    Lisalesanne 1. Teostada maxSagedus leidmine fuktsioonis lisaEesnimi()

    Lisalesanne 2. Muuta programmi andmestruktuuri jrgmiselt:

        - kustuta andmetp Perenimi
        - muuta andmetp Eesnimi jrgmiseks:

            struct Eesnimi
            {
                string enimi;
                vector<string> perenimed;
            };
*/
